diff --git a/hw/pc_piix.c b/hw/pc_piix.c
index 0c0096f..ef3840f 100644
--- a/hw/pc_piix.c
+++ b/hw/pc_piix.c
@@ -349,6 +349,18 @@ static void pc_xen_hvm_init(ram_addr_t ram_size,
 }
 #endif
 
+/* CPU aliases for pre-1.2 CPU models */
+#define V1_1_CPU_ALIASES  \
+    { "Conroe",      "Conroe-1.1" }, \
+    { "Penryn",      "Penryn-1.1" }, \
+    { "Nehalem",     "Nehalem-1.1" }, \
+    { "Westmere",    "Westmere-1.1" }, \
+    { "SandyBridge", "SandyBridge-1.1" }, \
+    { "Opteron_G1",  "Opteron_G1-1.1" }, \
+    { "Opteron_G2",  "Opteron_G2-1.1" }, \
+    { "Opteron_G3",  "Opteron_G3-1.1" }, \
+    { "Opteron_G4",  "Opteron_G4-1.1" },
+
 static QEMUMachine pc_machine_v1_2 = {
     .name = "pc-1.2",
     .alias = "pc",
@@ -356,6 +368,10 @@ static QEMUMachine pc_machine_v1_2 = {
     .init = pc_init_pci,
     .max_cpus = 255,
     .is_default = 1,
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #define PC_COMPAT_1_1 \
@@ -386,6 +402,10 @@ static QEMUMachine pc_machine_v1_1 = {
         PC_COMPAT_1_1,
         { /* end of list */ }
     },
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #define PC_COMPAT_1_0 \
@@ -422,6 +442,10 @@ static QEMUMachine pc_machine_v1_0 = {
         { /* end of list */ }
     },
     .hw_version = "1.0",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #define PC_COMPAT_0_15 \
@@ -437,6 +461,10 @@ static QEMUMachine pc_machine_v0_15 = {
         { /* end of list */ }
     },
     .hw_version = "0.15",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #define PC_COMPAT_0_14 \
@@ -478,6 +506,10 @@ static QEMUMachine pc_machine_v0_14 = {
         { /* end of list */ }
     },
     .hw_version = "0.14",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #define PC_COMPAT_0_13 \
@@ -515,6 +547,10 @@ static QEMUMachine pc_machine_v0_13 = {
         { /* end of list */ }
     },
     .hw_version = "0.13",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #define PC_COMPAT_0_12 \
@@ -548,6 +584,10 @@ static QEMUMachine pc_machine_v0_12 = {
         { /* end of list */ }
     },
     .hw_version = "0.12",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #define PC_COMPAT_0_11 \
@@ -581,6 +621,10 @@ static QEMUMachine pc_machine_v0_11 = {
         { /* end of list */ }
     },
     .hw_version = "0.11",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 static QEMUMachine pc_machine_v0_10 = {
@@ -614,6 +658,10 @@ static QEMUMachine pc_machine_v0_10 = {
         { /* end of list */ }
     },
     .hw_version = "0.10",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 static QEMUMachine isapc_machine = {
@@ -629,6 +677,10 @@ static QEMUMachine isapc_machine = {
         },
         { /* end of list */ }
     },
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 
 #ifdef CONFIG_XEN
@@ -638,6 +690,10 @@ static QEMUMachine xenfv_machine = {
     .init = pc_xen_hvm_init,
     .max_cpus = HVM_MAX_VCPUS,
     .default_machine_opts = "accel=xen",
+    .cpu_aliases = (CPUModelAlias[]) {
+        V1_1_CPU_ALIASES
+        {NULL, NULL},
+    },
 };
 #endif
 
diff --git a/sysconfigs/target/cpus-x86_64.conf b/sysconfigs/target/cpus-x86_64.conf
index cee0ea9..14c7891 100644
--- a/sysconfigs/target/cpus-x86_64.conf
+++ b/sysconfigs/target/cpus-x86_64.conf
@@ -1,7 +1,7 @@
 # x86 CPU MODELS
 
 [cpudef]
-   name = "Conroe"
+   name = "Conroe-1.1"
    level = "2"
    vendor = "GenuineIntel"
    family = "6"
@@ -15,7 +15,7 @@
    model_id = "Intel Celeron_4x0 (Conroe/Merom Class Core 2)"
 
 [cpudef]
-   name = "Penryn"
+   name = "Penryn-1.1"
    level = "2"
    vendor = "GenuineIntel"
    family = "6"
@@ -29,7 +29,7 @@
    model_id = "Intel Core 2 Duo P9xxx (Penryn Class Core 2)"
 
 [cpudef]
-   name = "Nehalem"
+   name = "Nehalem-1.1"
    level = "2"
    vendor = "GenuineIntel"
    family = "6"
@@ -43,7 +43,7 @@
    model_id = "Intel Core i7 9xx (Nehalem Class Core i7)"
 
 [cpudef]
-   name = "Westmere"
+   name = "Westmere-1.1"
    level = "11"
    vendor = "GenuineIntel"
    family = "6"
@@ -57,7 +57,7 @@
    model_id = "Westmere E56xx/L56xx/X56xx (Nehalem-C)"
 
 [cpudef]
-   name = "SandyBridge"
+   name = "SandyBridge-1.1"
    level = "0xd"
    vendor = "GenuineIntel"
    family = "6"
@@ -71,7 +71,7 @@
    model_id = "Intel Xeon E312xx (Sandy Bridge)"
 
 [cpudef]
-   name = "Opteron_G1"
+   name = "Opteron_G1-1.1"
    level = "5"
    vendor = "AuthenticAMD"
    family = "15"
@@ -85,7 +85,7 @@
    model_id = "AMD Opteron 240 (Gen 1 Class Opteron)"
 
 [cpudef]
-   name = "Opteron_G2"
+   name = "Opteron_G2-1.1"
    level = "5"
    vendor = "AuthenticAMD"
    family = "15"
@@ -99,7 +99,7 @@
    model_id = "AMD Opteron 22xx (Gen 2 Class Opteron)"
 
 [cpudef]
-   name = "Opteron_G3"
+   name = "Opteron_G3-1.1"
    level = "5"
    vendor = "AuthenticAMD"
    family = "15"
@@ -113,7 +113,7 @@
    model_id = "AMD Opteron 23xx (Gen 3 Class Opteron)"
 
 [cpudef]
-   name = "Opteron_G4"
+   name = "Opteron_G4-1.1"
    level = "0xd"
    vendor = "AuthenticAMD"
    family = "21"